# 发送消息携带@信息



> 仅群组中支持 @ 消息功能，满足您 @ 指定用户或 @ 所有人的需求，在 `RCMessageContent` 类中新增 @ 属性

#### 消息中的 @ 提醒信息

```dart
MentionedInfo mentionedInfo;
```

#### MentionedInfo 结构

```dart
// 消息中的 @ 提醒信息
class MentionedInfo {
  // @ 提醒的类型，参见枚举 [RCMentionedType]
  int/*RCMentionedType*/ type;
  // @ 的用户 ID 列表，如果 type 是 @ 所有人，则可以传 nil
  List<String> userIdList; 
  // 包含 @ 提醒的消息，本地通知和远程推送显示的内容
  String mentionedContent; 
}
```



## 发送方：

发送消息的时候如果需要 @ 提示，可以给消息的 `mentionedInfo`  赋值

以 TextMessage 为例：

```dart
import 'package:rongcloud_im_plugin/rongcloud_im_plugin.dart' as prefix ;


void _sendMessageAddMentionedInfo() async {
  prefix.TextMessage msg = new prefix.TextMessage();
  msg.content = "测试文本消息携带@信息";
  /*
  测试携带 @ 信息
  */
  prefix.MentionedInfo mentionedInfo = new prefix.MentionedInfo();
  mentionedInfo.type = prefix.RCMentionedType.Users;
  mentionedInfo.userIdList = ["SealTalk"];
  mentionedInfo.mentionedContent = "这是 mentionedContent";
  msg.mentionedInfo = mentionedInfo;

  prefix.Message message = await prefix.RongIMClient.sendMessage(prefix.RCConversationType.Private, "SealTalk", msg);
  print("send message add mentionedInfo:"+message.content.getObjectName()+" msgContent:"+message.content.encode());
}
```



## 接收方：

收到 @ 消息时，在 `RCConversation` 里的 `mentionedCount` （会话中  @消息的个数）就会大于 0，可以根据 `mentionedCount` 是否大于 0 来决定是否展示 [有人@我]。在清除会话未读数（`clearMessagesUnreadStatus`）的时候，会将此值清空。

```dart
String digest = "";
// 获取会话中最后一条消息的内容
if(conversation.latestMessageContent != null) {
  digest = conversation.latestMessageContent.conversationDigest();
}
if(digest == null) {
  digest = "";
}
// 获取是否有人 @ 我
if (conversation.mentionedCount > 0) {
  digest = "[有人@我] " + digest;
}
```



#### RCMentionedType

```dart
//@ 提醒的类型
class RCMentionedType {
  static const int All = 1;//@所有人
  static const int Users =2;//@部分指定用户
}
```

