# 发送消息携带用户信息

##### 消息内容中携带的发送者的用户信息

```dart
UserInfo sendUserInfo;
```



##### UserInfo 结构

```dart
class UserInfo {
  // 用户 ID
  String userId;
  // 用户名称
  String name;
  // 用户头像的 URL
  String portraitUri;
  // 用户信息附加字段，建议附加字段使用 json 来进行数据传递
  String extra;
}
```

#### 发送方：

> 建议 App 层将当前登录用户的信息保存下来，在需要携带当前登录用户信息时给消息的 sendUserInfo 赋值。

以 TextMessage 为例，构造消息后给消息的 sendUserInfo 赋值即可：

```dart
import 'package:rongcloud_im_plugin/rongcloud_im_plugin.dart' as prefix ;


void _sendMessageAddSendUserInfo() async {
  prefix.TextMessage msg = new prefix.TextMessage();
  msg.content = "测试文本消息携带用户信息";
  /*
  测试携带用户信息
  */
  prefix.UserInfo sendUserInfo = new prefix.UserInfo();
  sendUserInfo.name = "textSendUser.name";
  sendUserInfo.userId = "textSendUser.userId";
  sendUserInfo.portraitUri = "textSendUser.portraitUrl";
  msg.sendUserInfo = sendUserInfo;

  prefix.Message message = await prefix.RongIMClient.sendMessage(prefix.RCConversationType.Private, "SealTalk", msg);
  print("send message add sendUserInfo:"+message.content.getObjectName()+" msgContent:"+message.content.encode());
}
```


#### 接收方：

如果消息携带用户信息时，优先使用消息携带的用户信息展示；

如果消息未携带用户信息时，需要开发者可根据自己的业务处理进行用户信息的请求与显示。

```dart
UserInfo *sendUserInfo = message.content.senderUserInfo;
if (sendUserInfo != nil) {
		// 使用 sendUserInfo 的信息进行 UI 布局
} else {
		// 开发者可根据自己的业务处理进行用户信息的请求与显示
}
```