#  输入状态监听


### 1. 监听输入状态

##### 设置 onTypingStatusChanged 监听便能够监听到输入的状态，根据类型区分为 ‘文字输入’ ，‘语音输入’ 等状态，刷新 UI 展示不同状态

```dart
RongIMClient.onTypingStatusChanged =
        (int conversationType, String targetId, List typingStatus) async {
      if (conversationType == this.conversationType &&
          targetId == this.targetId) {
        if (typingStatus.length > 0) {
          TypingStatus status = typingStatus[typingStatus.length - 1];
          if (status.typingContentType == TextMessage.objectName) {
            titleContent = '对方正在输入...';
          } else if (status.typingContentType == VoiceMessage.objectName ||
              status.typingContentType == 'RC:VcMsg') {
            titleContent = '对方正在讲话...';
          }
        } else {
          titleContent = '与 $targetId 的会话';
        }
        _refreshUI();
      }
    };
```

### 2. 发送输入状态
> #### 注：必须发送状态，才能使得对端正常收到相应的状态

 1）可在正在输入文字的时候发送，文字输入状态，如监听 TextField 控件的 TextEditingController 监听到变化回调后发送输入状态

```dart
void onTextChange(String text) {
    // print('input ' + text);
    textDraft = text;
    RongIMClient.sendTypingStatus(
        conversationType, targetId, TextMessage.objectName);
  }
```

 2）可在开始启动录音准备发送语音消息时，发送语音输入状态

```dart
void willStartRecordVoice() {
    _showExtraCenterWidget(ConversationStatus.VoiceRecorder);
    RongIMClient.sendTypingStatus(conversationType, targetId, 'RC:VcMsg');
  }
```

