# 阅后即焚


> 阅后即焚逻辑：
1. UserA 发送阅后即焚消息，即发消息时携带 destructDuration
2. UserB 收到阅后即焚消息，查看阅后即焚消息（点击查看）时调用 messageBeginDestruct 方法开始焚烧消息
3. UserB 此时会收到阅后即焚消息正在焚烧的回调 onMessageDestructing，在这个回调中会返回正在焚烧的消息 Id 和剩余时间，更新 UI 即可



#### 1、发送阅后即焚消息

需要发送阅后即焚消息时，需要对消息的 destructDuration 赋值：

```dart
TextMessage msg = new TextMessage();
msg.content = "contentStr";
if (conversationType == RCConversationType.Private) {
    int duration = 20;
    msg.destructDuration = isSecretChat ? duration : 0;
}

Message message = await RongIMClient.sendMessage(conversationType, targetId, msg);
```


#### 2、接收到阅后即焚消息并点击查看消息时的处理

当接收到阅后即焚消息时，需要触发查看阅后即焚消息的方法才会开始焚烧消息。

```dart
RongIMClient.messageBeginDestruct(message);
```


#### 3、接收到阅后即焚消息后点击查看后的回调方法

当接收到阅后即焚消息并点击查看后，接收方会走 onMessageDestructing 方法，这个方法会返回正在焚烧的消息以及剩余时间

```dart
RongIMClient.onMessageDestructing = (Message message, int remainDuration) async {
    print(message.toString() + remainDuration.toString());
    // 需更新对应的消息
};
```
